=== docs/requirements.txt ===
autodocsumm
pydantic
sentencepiece
sphinx == 5.2.3
sphinx-reredirects==0.1.2
sphinx-rtd-theme
sphinx-tabs == 3.4.1
sphinx-toolbox == 3.4.0
sphinxcontrib-napoleon==0.7
sphinxcontrib_httpdomain==1.8.1
tiktoken
tlcpack-sphinx-addon==0.2.2
torch
transformers
