=== debian/control ===
Source: xgrammar
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Kohei Sendai <kouhei.sendai@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-scikit-build-core,
 python3-nanobind,
 python3-setuptools,
 python3-all,
 python3-dev,
 python3-pydantic,
 python3-transformers,
 python3-torch | python3-torch-cuda,
 python3-sentencepiece,
 python3-tiktoken,
 python3-transformers,
 ninja-build,
 libdlpack-dev,
 cmake
#Testsuite: autopkgtest-pkg-python
Standards-Version: 4.7.2
Homepage: https://github.com/mlc-ai/xgrammar
Vcs-Browser: https://salsa.debian.org/python-team/packages/xgrammar
Vcs-Git: https://salsa.debian.org/python-team/packages/xgrammar.git

Package: python3-xgrammar
Architecture: amd64 arm64
Depends:
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
Description: Efficient, Flexible and Portable Structured Generation
 XGrammar is an open-source library for efficient, flexible, 
 and portable structured generation. It supports general 
 context-free grammar to enable a broad range of structures 
 while bringing careful system optimizations to enable fast 
 executions. XGrammar features a minimal and portable C++ backend
 that can be easily integrated into multiple environments and 
 frameworks, and is co-designed with the LLM inference engine 
 and enables zero-overhead structured generation in LLM inference.
