=== debian/tests/control ===
Test-Command: cd tests/python ; HOME=$AUTOPKGTEST_TMP pytest-3 -v test_grammar_parser.py
Depends: @, python3-pytest, python3-pytest-mock, python3-pytest-env, python3-protobuf
Restrictions: allow-stderr
Features: test-name=pytest-grammar-parser

Test-Command: cd tests/python ; HOME=$AUTOPKGTEST_TMP pytest-3 -v test_grammar_union_concat.py
Depends: @, python3-pytest, python3-pytest-mock, python3-pytest-env, python3-protobuf
Restrictions: allow-stderr
Features: test-name=pytest-grammar-union_concat

Test-Command: cd tests/python ; HOME=$AUTOPKGTEST_TMP pytest-3 -v test_json_schema_converter.py
Depends: @, python3-pytest, python3-pytest-mock, python3-pytest-env, python3-protobuf
Restrictions: allow-stderr
Features: test-name=pytest-json-schema-converter

Test-Command: cd tests/python ; HOME=$AUTOPKGTEST_TMP pytest-3 -v test_token_bitmask_operations.py
Depends: @, python3-pytest, python3-pytest-mock, python3-pytest-env, python3-protobuf
Restrictions: allow-stderr
Features: test-name=pytest-test_token-bitmask-operations
