=== debian/watch ===
version=4
# GitHub hosted projects.
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/mlc-ai/xgrammar/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
